#include "sprite.h"

// Constructor
Sprite::Sprite(int x, int y, int w, int h, std::shared_ptr<Texture> texture)
	: x_(x), y_(y), w_(w), h_(h), texture_(texture)
{
	// Establece el rectangulo de donde coger la imagen
	spriteClip_ = {0, 0, w, h};

	// Inicializa variables
	enabled_ = true;
}

Sprite::Sprite(SDL_Rect rect, std::shared_ptr<Texture> texture)
	: x_(rect.x), y_(rect.y), w_(rect.w), h_(rect.h), texture_(texture)
{
	// Establece el rectangulo de donde coger la imagen
	spriteClip_ = {0, 0, w_, h_};

	// Inicializa variables
	enabled_ = true;
}

// Muestra el sprite por pantalla
void Sprite::render()
{
	if (enabled_)
	{
		texture_->render(x_, y_, &spriteClip_);
	}
}

// Obten el valor de la variable
int Sprite::getPosX() const
{
	return x_;
}

// Obten el valor de la variable
int Sprite::getPosY() const
{
	return y_;
}

// Obten el valor de la variable
int Sprite::getWidth() const
{
	return w_;
}

// Obten el valor de la variable
int Sprite::getHeight() const
{
	return h_;
}

// Establece la posición del objeto
void Sprite::setPos(int x, int y)
{
	x_ = x;
	y_ = y;
}

// Establece la posición del objeto
void Sprite::setPos(SDL_Point p)
{
	x_ = p.x;
	y_ = p.y;
}

// Establece la posición del objeto
void Sprite::setPos(SDL_Rect r)
{
	x_ = r.x;
	y_ = r.y;
	w_ = r.w;
	h_ = r.h;
}

// Establece el valor de la variable
void Sprite::setPosX(int x)
{
	x_ = x;
}

// Establece el valor de la variable
void Sprite::setPosY(int y)
{
	y_ = y;
}

// Establece el valor de la variable
void Sprite::setWidth(int w)
{
	w_ = w;
}

// Establece el valor de la variable
void Sprite::setHeight(int h)
{
	h_ = h;
}

// Obten el valor de la variable
SDL_Rect Sprite::getSpriteClip() const
{
	return spriteClip_;
}

// Establece el valor de la variable
void Sprite::setSpriteClip(SDL_Rect rect)
{
	spriteClip_ = rect;
}

// Establece el valor de la variable
void Sprite::setSpriteClip(int x, int y, int w, int h)
{
	spriteClip_ = (SDL_Rect){x, y, w, h};
}

// Obten el valor de la variable
std::shared_ptr<Texture> Sprite::getTexture() const
{
	return texture_;
}

// Establece el valor de la variable
void Sprite::setTexture(std::shared_ptr<Texture> texture)
{
	texture_ = texture;
}

// Establece el valor de la variable
void Sprite::setEnabled(bool value)
{
	enabled_ = value;
}

// Comprueba si el objeto está habilitado
bool Sprite::isEnabled() const
{
	return enabled_;
}

// Devuelve el rectangulo donde está el sprite
SDL_Rect Sprite::getRect() const
{
	return (SDL_Rect){x_, y_, w_, h_};
}

// Incrementa el valor de la variable
void Sprite::incPosX(int value)
{
	x_ += value;
}

// Incrementa el valor de la variable
void Sprite::incPosY(int value)
{
	y_ += value;
}